﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Initializers {
  class Program {
    static void Main(string[] args) {
      var person1 = new Person("Willy", 33);
      var person2 = new Person {
                      Name = "Anna",
                      Age = 35
                    };

      // This doesn't really make any sense here, but it works:
      var person3 = new Person("Willy", 33) {
                      Name = "Anna",
                      Age = 35
                    };

      var people = new List<Person> {
                     new Person("Willy", 33),
                     new Person {
                       Name = "Anna",
                       Age = 35
                     }
                   };

      // Implicitely typed arrays look like they have to do with
      // initializers, but they are a separate feature.

      var numbers = new[] { 1, 2, 3 };

    }

    class Person {
      public Person( ) { }

      public Person(string name, int age) {
        this.Name = name;
        this.Age = age;
      }

      public string Name { get; set; }
      public int Age { get; set; }
    }
  }
}
